Index: trunk/lib/App.inc.php
===================================================================
--- trunk/lib/App.inc.php	(revision 124)
+++ trunk/lib/App.inc.php	(revision 136)
@@ -946,20 +890,20 @@
             $url = preg_replace('/boomerang=[\w]+/', '', $url);
 
-            if (isset($_SESSION[$_this->app]['boomerang']['url']) && is_array($_SESSION[$_this->app]['boomerang']['url']) && !empty($_SESSION[$_this->app]['boomerang']['url'])) {
+            if (isset($_SESSION[$this->_ns]['boomerang']['url']) && is_array($_SESSION[$this->_ns]['boomerang']['url']) && !empty($_SESSION[$this->_ns]['boomerang']['url'])) {
                 // If the URL currently exists in the boomerang array, delete.
-                while ($existing_key = array_search($url, $_SESSION[$_this->app]['boomerang']['url'])) {
-                    unset($_SESSION[$_this->app]['boomerang']['url'][$existing_key]);
+                while ($existing_key = array_search($url, $_SESSION[$this->_ns]['boomerang']['url'])) {
+                    unset($_SESSION[$this->_ns]['boomerang']['url'][$existing_key]);
                 }
             }
 
             if (isset($id)) {
-                $_SESSION[$_this->app]['boomerang']['url'][$id] = $url;
+                $_SESSION[$this->_ns]['boomerang']['url'][$id] = $url;
             } else {
-                $_SESSION[$_this->app]['boomerang']['url'][] = $url;
-            }
-            $_this->logMsg(sprintf('setBoomerangURL(%s): %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
+                $_SESSION[$this->_ns]['boomerang']['url'][] = $url;
+            }
+            $this->logMsg(sprintf('setBoomerangURL(%s): %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
             return true;
         } else {
-            $_this->logMsg(sprintf('setBoomerangURL(%s) is empty!', $id, $url), LOG_NOTICE, __FILE__, __LINE__);
+            $this->logMsg(sprintf('setBoomerangURL(%s) is empty!', $id, $url), LOG_NOTICE, __FILE__, __LINE__);
             return false;
         }
@@ -973,21 +917,17 @@
     function getBoomerangURL($id=null)
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
-        if (!$_this->running) {
-            $_this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_DEBUG, __FILE__, __LINE__);
+        if (!$this->running) {
+            $this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_NOTICE, __FILE__, __LINE__);
             return false;
         }
 
         if (isset($id)) {
-            if (isset($_SESSION[$_this->app]['boomerang']['url'][$id])) {
-                return $_SESSION[$_this->app]['boomerang']['url'][$id];
+            if (isset($_SESSION[$this->_ns]['boomerang']['url'][$id])) {
+                return $_SESSION[$this->_ns]['boomerang']['url'][$id];
             } else {
                 return '';
             }
-        } else if (is_array($_SESSION[$_this->app]['boomerang']['url'])) {
-            return end($_SESSION[$_this->app]['boomerang']['url']);
+        } else if (is_array($_SESSION[$this->_ns]['boomerang']['url'])) {
+            return end($_SESSION[$this->_ns]['boomerang']['url']);
         } else {
             return false;
@@ -1002,19 +942,15 @@
     function deleteBoomerangURL($id=null)
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
-        if (!$_this->running) {
-            $_this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_DEBUG, __FILE__, __LINE__);
-            return false;
-        }
-
-        $_this->logMsg(sprintf('deleteBoomerangURL(%s): %s', $id, $_this->getBoomerangURL($id)), LOG_DEBUG, __FILE__, __LINE__);
-
-        if (isset($id) && isset($_SESSION[$_this->app]['boomerang']['url'][$id])) {
-            unset($_SESSION[$_this->app]['boomerang']['url'][$id]);
-        } else if (is_array($_SESSION[$_this->app]['boomerang']['url'])) {
-            array_pop($_SESSION[$_this->app]['boomerang']['url']);
+        if (!$this->running) {
+            $this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_NOTICE, __FILE__, __LINE__);
+            return false;
+        }
+
+        $this->logMsg(sprintf('deleteBoomerangURL(%s): %s', $id, $this->getBoomerangURL($id)), LOG_DEBUG, __FILE__, __LINE__);
+
+        if (isset($id) && isset($_SESSION[$this->_ns]['boomerang']['url'][$id])) {
+            unset($_SESSION[$this->_ns]['boomerang']['url'][$id]);
+        } else if (is_array($_SESSION[$this->_ns]['boomerang']['url'])) {
+            array_pop($_SESSION[$this->_ns]['boomerang']['url']);
         }
     }
@@ -1028,15 +964,11 @@
     function validBoomerangURL($id=null, $use_nonspecificboomerang=false)
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
-        if (!$_this->running) {
-            $_this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_DEBUG, __FILE__, __LINE__);
-            return false;
-        }
-
-        if (!isset($_SESSION[$_this->app]['boomerang']['url'])) {
-            $_this->logMsg(sprintf('validBoomerangURL(%s) no boomerang URL set.', $id), LOG_DEBUG, __FILE__, __LINE__);
+        if (!$this->running) {
+            $this->logMsg(sprintf('Canceled method call %s, application not running.', __FUNCTION__), LOG_NOTICE, __FILE__, __LINE__);
+            return false;
+        }
+
+        if (!isset($_SESSION[$this->_ns]['boomerang']['url'])) {
+            $this->logMsg(sprintf('validBoomerangURL(%s) no boomerang URL set.', $id), LOG_DEBUG, __FILE__, __LINE__);
             return false;
         }
@@ -1045,32 +977,32 @@
         // a boomerang redirection will always occur at least several seconds after the last boomerang redirect
         // or a boomerang being set.
-        $boomerang_time = isset($_SESSION[$_this->app]['boomerang']['time']) ? $_SESSION[$_this->app]['boomerang']['time'] : 0;
+        $boomerang_time = isset($_SESSION[$this->_ns]['boomerang']['time']) ? $_SESSION[$this->_ns]['boomerang']['time'] : 0;
 
         $url = '';
-        if (isset($id) && isset($_SESSION[$_this->app]['boomerang']['url'][$id])) {
-            $url = $_SESSION[$_this->app]['boomerang']['url'][$id];
+        if (isset($id) && isset($_SESSION[$this->_ns]['boomerang']['url'][$id])) {
+            $url = $_SESSION[$this->_ns]['boomerang']['url'][$id];
         } else if (!isset($id) || $use_nonspecificboomerang) {
             // Use non specific boomerang if available.
-            $url = end($_SESSION[$_this->app]['boomerang']['url']);
-        }
-
-        $_this->logMsg(sprintf('validBoomerangURL(%s) testing: %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
+            $url = end($_SESSION[$this->_ns]['boomerang']['url']);
+        }
+
+        $this->logMsg(sprintf('validBoomerangURL(%s) testing: %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
 
         if ('' == $url) {
-            $_this->logMsg(sprintf('validBoomerangURL(%s) not valid, empty!', $id), LOG_DEBUG, __FILE__, __LINE__);
+            $this->logMsg(sprintf('validBoomerangURL(%s) not valid, empty!', $id), LOG_DEBUG, __FILE__, __LINE__);
             return false;
         }
         if ($url == absoluteMe()) {
             // The URL we are directing to is the current page.
-            $_this->logMsg(sprintf('validBoomerangURL(%s) not valid, same as absoluteMe: %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
+            $this->logMsg(sprintf('validBoomerangURL(%s) not valid, same as absoluteMe: %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
             return false;
         }
         if ($boomerang_time >= (time() - 2)) {
             // Last boomerang direction was more than 2 seconds ago.
-            $_this->logMsg(sprintf('validBoomerangURL(%s) not valid, boomerang_time too short: %s', $id, time() - $boomerang_time), LOG_DEBUG, __FILE__, __LINE__);
-            return false;
-        }
-
-        $_this->logMsg(sprintf('validBoomerangURL(%s) is valid: %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
+            $this->logMsg(sprintf('validBoomerangURL(%s) not valid, boomerang_time too short: %s', $id, time() - $boomerang_time), LOG_DEBUG, __FILE__, __LINE__);
+            return false;
+        }
+
+        $this->logMsg(sprintf('validBoomerangURL(%s) is valid: %s', $id, $url), LOG_DEBUG, __FILE__, __LINE__);
         return true;
     }
@@ -1082,8 +1014,4 @@
     function sslOn()
     {
-        if (!isset($_this) || !is_a($_this, 'App') && !is_subclass_of($_this, 'App')) {
-            $_this =& App::getInstance();
-        }
-
         if (function_exists('apache_get_modules')) {
             $modules = apache_get_modules();
@@ -1093,8 +1021,8 @@
         }
 
-        if ('' == getenv('HTTPS') && $_this->getParam('ssl_enabled') && in_array('mod_ssl', $modules)) {
-            $_this->raiseMsg(sprintf(_("Secure SSL connection made to %s"), $_this->getParam('ssl_domain')), MSG_NOTICE, __FILE__, __LINE__);
+        if ('' == getenv('HTTPS') && $this->getParam('ssl_enabled') && in_array('mod_ssl', $modules)) {
+            $this->raiseMsg(sprintf(_("Secure SSL connection made to %s"), $this->getParam('ssl_domain')), MSG_NOTICE, __FILE__, __LINE__);
             // Always append session because some browsers do not send cookie when crossing to SSL URL.
-            $_this->dieURL('https://' . $_this->getParam('ssl_domain') . getenv('REQUEST_URI'), null, true);
+            $this->dieURL('https://' . $this->getParam('ssl_domain') . getenv('REQUEST_URI'), null, true);
         }
     }
@@ -1107,8 +1035,4 @@
     function sslOff()
     {
-        if (!isset($this) || !is_a($this, 'App') && !is_subclass_of($this, 'App')) {
-            $this =& App::getInstance();
-        }
-
         if ('' != getenv('HTTPS')) {
             $this->dieURL('http://' . getenv('HTTP_HOST') . getenv('REQUEST_URI'), null, true);
Index: trunk/lib/Auth_File.inc.php
===================================================================
--- trunk/lib/Auth_File.inc.php	(revision 124)
+++ trunk/lib/Auth_File.inc.php	(revision 136)
@@ -1,5 +1,8 @@
 <?php
 /**
- * The Auth_File:: class provides a htpasswd file implementation for
+ * Auth_File.inc.php
+ * code by strangecode :: www.strangecode.com :: this document contains copyrighted information
+ *
+ * The Auth_File class provides a htpasswd file implementation for
  * authentication.
  *
@@ -24,7 +27,9 @@
 
 class Auth_File {
-
-    var $_auth = '';
-    var $_sess = '_auth_';
+    
+    // Namespace of this auth object.
+    var $_ns;
+    
+    // Parameters to be specified by setParam().
     var $_params = array();
     var $_default_params = array(
@@ -61,10 +66,7 @@
      * @param optional array $params  A hash containing parameters.
      */
-    function Auth_File($auth_name=null)
-    {
-        if (isset($auth_name)) {
-            $this->_auth = $auth_name;
-            $this->_sess .= $auth_name;
-        }
+    function Auth_File($namespace='null')
+    {
+        $this->_ns = '_auth_' . $namespace;
 
         // Initialize default parameters.
@@ -95,8 +97,10 @@
     function getParam($param)
     {
+		$app =& App::getInstance();
+    
         if (isset($this->_params[$param])) {
             return $this->_params[$param];
         } else {
-            App::logMsg(sprintf('Parameter is not set: %s', $param), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Parameter is not set: %s', $param), LOG_NOTICE, __FILE__, __LINE__);
             return null;
         }
@@ -110,5 +114,5 @@
     function clearAuth()
     {
-        $_SESSION[$this->_sess] = array('authenticated' => false);
+        $_SESSION[$this->_ns] = array('authenticated' => false);
     }
 
@@ -123,8 +127,8 @@
     function setVal($key, $val)
     {
-        if (!isset($_SESSION[$this->_sess]['user_data'])) {
-            $_SESSION[$this->_sess]['user_data'] = array();
-        }
-        $_SESSION[$this->_sess]['user_data'][$key] = $val;
+        if (!isset($_SESSION[$this->_ns]['user_data'])) {
+            $_SESSION[$this->_ns]['user_data'] = array();
+        }
+        $_SESSION[$this->_ns]['user_data'][$key] = $val;
     }
 
@@ -139,8 +143,8 @@
     function getVal($key, $default='')
     {
-        if (isset($_SESSION[$this->_sess][$key])) {
-            return $_SESSION[$this->_sess][$key];
-        } else if (isset($_SESSION[$this->_sess]['user_data'][$key])) {
-            return $_SESSION[$this->_sess]['user_data'][$key];
+        if (isset($_SESSION[$this->_ns][$key])) {
+            return $_SESSION[$this->_ns][$key];
+        } else if (isset($_SESSION[$this->_ns]['user_data'][$key])) {
+            return $_SESSION[$this->_ns]['user_data'][$key];
         } else {
             return $default;
@@ -160,6 +164,8 @@
     function authenticate($username, $password)
     {
+		$app =& App::getInstance();
+    
         if ('' == trim($password)) {
-            App::logMsg(_("No password provided for authentication."), LOG_INFO, __FILE__, __LINE__);
+            $app->logMsg(_("No password provided for authentication."), LOG_INFO, __FILE__, __LINE__);
             return false;
         }
@@ -169,10 +175,10 @@
 
         if (!isset($this->_users[$username])) {
-            App::logMsg(_("User ID provided does not exist."), LOG_INFO, __FILE__, __LINE__);
+            $app->logMsg(_("User ID provided does not exist."), LOG_INFO, __FILE__, __LINE__);
             return false;
         }
 
         if ($this->_encrypt($password, $this->_users[$username]) != $this->_users[$username]) {
-            App::logMsg(sprintf('Authentication failed for user %s', $username), LOG_INFO, __FILE__, __LINE__);
+            $app->logMsg(sprintf('Authentication failed for user %s', $username), LOG_INFO, __FILE__, __LINE__);
             return false;
         }
@@ -203,5 +209,5 @@
         }
         
-        $_SESSION[$this->_sess] = array(
+        $_SESSION[$this->_ns] = array(
             'authenticated' => true,
             'username' => $username,
@@ -227,11 +233,13 @@
     function isLoggedIn()
     {
+		$app =& App::getInstance();
+    
         // Some users will access from networks with a changing IP number (i.e. behind a proxy server). These users must be allowed entry by adding their IP to the list of trusted_networks.
         if ($trusted_net = ipInRange(getRemoteAddr(), $this->_params['trusted_networks'])) {
             $user_in_trusted_network = true;
-            App::logMsg(sprintf('User %s accessing from trusted network %s', $_SESSION[$this->_sess]['username'], $trusted_net), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('User %s accessing from trusted network %s', $_SESSION[$this->_ns]['username'], $trusted_net), LOG_DEBUG, __FILE__, __LINE__);
         } else if (preg_match('/proxy.aol.com$/i', getRemoteAddr(true))) {
             $user_in_trusted_network = true;
-            App::logMsg(sprintf('User %s accessing from trusted network proxy.aol.com', $_SESSION[$this->_sess]['username']), LOG_DEBUG, __FILE__, __LINE__);
+            $app->logMsg(sprintf('User %s accessing from trusted network proxy.aol.com', $_SESSION[$this->_ns]['username']), LOG_DEBUG, __FILE__, __LINE__);
         } else {
             $user_in_trusted_network = false;
@@ -239,35 +247,35 @@
 
         // Test login with information stored in session. Skip IP matching for users from trusted networks.
-        if (isset($_SESSION[$this->_sess])
-            && true === $_SESSION[$this->_sess]['authenticated']
-            && !empty($_SESSION[$this->_sess]['username'])
-            && strtotime($_SESSION[$this->_sess]['login_datetime']) > time() - $this->_params['login_timeout']
-            && strtotime($_SESSION[$this->_sess]['last_access_datetime']) > time() - $this->_params['idle_timeout']
-            && ($_SESSION[$this->_sess]['remote_ip'] == getRemoteAddr() || $user_in_trusted_network)
+        if (isset($_SESSION[$this->_ns])
+            && true === $_SESSION[$this->_ns]['authenticated']
+            && !empty($_SESSION[$this->_ns]['username'])
+            && strtotime($_SESSION[$this->_ns]['login_datetime']) > time() - $this->_params['login_timeout']
+            && strtotime($_SESSION[$this->_ns]['last_access_datetime']) > time() - $this->_params['idle_timeout']
+            && ($_SESSION[$this->_ns]['remote_ip'] == getRemoteAddr() || $user_in_trusted_network)
         ) {
             // User is authenticated!
-            $_SESSION[$this->_sess]['last_access_datetime'] = date('Y-m-d H:i:s');
+            $_SESSION[$this->_ns]['last_access_datetime'] = date('Y-m-d H:i:s');
             return true;
-        } else if (isset($_SESSION[$this->_sess]) && true === $_SESSION[$this->_sess]['authenticated']) {
-            if (strtotime($_SESSION[$this->_sess]['last_access_datetime']) > time() - 43200) {
+        } else if (isset($_SESSION[$this->_ns]) && true === $_SESSION[$this->_ns]['authenticated']) {
+            if (strtotime($_SESSION[$this->_ns]['last_access_datetime']) > time() - 43200) {
                 // Only raise message if last session is less than 12 hours old.
-                App::raiseMsg(_("Your session has closed. You need to log-in again."), MSG_NOTICE, __FILE__, __LINE__);
+                $app->raiseMsg(_("Your session has closed. You need to log-in again."), MSG_NOTICE, __FILE__, __LINE__);
             }
 
             // Log the reason for login expiration.
             $expire_reasons = array();
-            if (empty($_SESSION[$this->_sess]['username'])) {
+            if (empty($_SESSION[$this->_ns]['username'])) {
                 $expire_reasons[] = 'username not found';
             }
-            if (strtotime($_SESSION[$this->_sess]['login_datetime']) <= time() - $this->_params['login_timeout']) {
+            if (strtotime($_SESSION[$this->_ns]['login_datetime']) <= time() - $this->_params['login_timeout']) {
                 $expire_reasons[] = 'login_timeout expired';
             }
-            if (strtotime($_SESSION[$this->_sess]['last_access_datetime']) <= time() - $this->_params['idle_timeout']) {
+            if (strtotime($_SESSION[$this->_ns]['last_access_datetime']) <= time() - $this->_params['idle_timeout']) {
                 $expire_reasons[] = 'idle_timeout expired';
             }
-            if ($_SESSION[$this->_sess]['remote_ip'] != getRemoteAddr() && !$user_in_trusted_network) {
-                $expire_reasons[] = sprintf('remote_ip not matched (%s != %s)', $_SESSION[$this->_sess]['remote_ip'], getRemoteAddr());
-            }
-            App::logMsg(sprintf('User %s session expired: %s', $_SESSION[$this->_sess]['username'], join(', ', $expire_reasons)), LOG_INFO, __FILE__, __LINE__);
+            if ($_SESSION[$this->_ns]['remote_ip'] != getRemoteAddr() && !$user_in_trusted_network) {
+                $expire_reasons[] = sprintf('remote_ip not matched (%s != %s)', $_SESSION[$this->_ns]['remote_ip'], getRemoteAddr());
+            }
+            $app->logMsg(sprintf('User %s session expired: %s', $_SESSION[$this->_ns]['username'], join(', ', $expire_reasons)), LOG_INFO, __FILE__, __LINE__);
         }
 
@@ -287,11 +295,13 @@
     function requireLogin($message='', $type=MSG_NOTICE, $file=null, $line=null)
     {
+		$app =& App::getInstance();
+    
         if (!$this->isLoggedIn()) {
             // Display message for requiring login. (RaiseMsg will ignore empty strings.)
-            App::raiseMsg($message, $type, $file, $line);
+            $app->raiseMsg($message, $type, $file, $line);
 
             // Login scripts must have the same 'login' tag for boomerangURL verification/manipulation.
-            App::setBoomerangURL(absoluteMe(), 'login');
-            App::dieURL($this->_params['login_url']);
+            $app->setBoomerangURL(absoluteMe(), 'login');
+            $app->dieURL($this->_params['login_url']);
         }
     }
@@ -308,8 +318,10 @@
     function _loadHTPasswdFile()
     {
+		$app =& App::getInstance();
+    
         static $users = null;
         
         if (!file_exists($this->_params['htpasswd_file'])) {
-            App::logMsg(sprintf('htpasswd file missing or not specified: %s', $this->_params['htpasswd_file']), LOG_ERR, __FILE__, __LINE__);
+            $app->logMsg(sprintf('htpasswd file missing or not specified: %s', $this->_params['htpasswd_file']), LOG_ERR, __FILE__, __LINE__);
             return false;
         }
@@ -317,5 +329,5 @@
         if (!isset($users)) {
             if (false === ($users = file($this->_params['htpasswd_file']))) {
-                App::logMsg(sprintf(_("Could not read htpasswd file: %s"), $this->_params['htpasswd_file']), LOG_ERR, __FILE__, __LINE__);
+                $app->logMsg(sprintf(_("Could not read htpasswd file: %s"), $this->_params['htpasswd_file']), LOG_ERR, __FILE__, __LINE__);
                 return false;
             }
